"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
exports.default = (pages, _options) => `
module Gen.Route exposing
    ( Route(..)
    , fromUrl
    , toHref
    )

${utils_1.paramsImports(pages)}
import Url exposing (Url)
import Url.Parser as Parser exposing ((</>), Parser)


${utils_1.routeTypeDefinition(pages)}


fromUrl : Url -> Route
fromUrl =
    Parser.parse (Parser.oneOf routes) >> Maybe.withDefault NotFound


routes : List (Parser (Route -> a) a)
routes =
${utils_1.indent(utils_1.routeParserList(pages), 1)}


toHref : Route -> String
toHref route =
    let
        joinAsHref : List String -> String
        joinAsHref segments =
            "/" ++ String.join "/" segments
    in
${utils_1.indent(utils_1.routeToHref(pages), 1)}

`.trimLeft();
